/// <reference types="node" />
import { ConnectConfig, ExecOptions, ShellOptions } from 'ssh2';
import { Event as EventEmitter } from '@zodash/event';
export interface ClientConfig extends ConnectConfig {
}
export interface ClientSpawnEvents {
    error(error: Error): void;
    data(data: string | Buffer): void;
    close(): void;
}
export declare class Client {
    private readonly config?;
    private client;
    private _isReady;
    constructor(config?: ClientConfig);
    private ensureReady;
    get isReady(): boolean;
    connect(config?: ClientConfig): Promise<void>;
    close(): Promise<void>;
    exec(command: string, options?: ExecOptions): Promise<unknown>;
    spawn(command: string, options?: ShellOptions): EventEmitter<ClientSpawnEvents> & {
        close(): void;
        destroy(): void;
    };
}
export declare function exec(command: string, config: ClientConfig, options?: ExecOptions): Promise<unknown>;
